//+------------------------------------------------------------------+
//|                                            
//+------------------------------------------------------------------+


#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2


extern int MagicNumber = 456879;
extern double Risk = 10;
extern double SL = 650;
extern double TP = 1800;


int BarCount;
int Current;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   BarCount = Bars;
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   int Order = SIGNAL_NONE;
   int Total, Ticket;
   
   Total = OrdersTotal();
   Order = SIGNAL_NONE;
//+------------------------------------------------------------------+
//| Variable Begin                                                   |
//+------------------------------------------------------------------+


double BuyPT1_1 = iCustom(NULL,0,"PriceTrender",240,0,0,0,24,1,2); //trend before
double BuyPT1_2 = iCustom(NULL,0,"PriceTrender",240,0,0,0,24,1,1); //trend now
double BuyPT2_1 = iCustom(NULL,0,"PriceTrender",240,0,0,0,24,0,2); //price before
double BuyPT2_2 = iCustom(NULL,0,"PriceTrender",240,0,0,0,24,0,1); // price now


double SellPT1_1 = iCustom(NULL,0,"PriceTrender",240,0,0,0,24,1,2);//trend before
double SellPT1_2 = iCustom(NULL,0,"PriceTrender",240,0,0,0,24,1,1);//trend now
double SellPT2_1 = iCustom(NULL,0,"PriceTrender",240,0,0,0,24,0,2);//price before
double SellPT2_2 = iCustom(NULL,0,"PriceTrender",240,0,0,0,24,0,1);//price now

double CLBuyPT1_1 = iCustom(NULL,0,"PriceTrender",240,0,0,0,24,1,2); //trend before
double CLBuyPT1_2 = iCustom(NULL,0,"PriceTrender",240,0,0,0,24,1,1); //trend now
double CLBuyPT2_1 = iCustom(NULL,0,"PriceTrender",240,0,0,0,24,0,2); //price before
double CLBuyPT2_2 = iCustom(NULL,0,"PriceTrender",240,0,0,0,24,0,1); // price now

double CLSellPT1_1 = iCustom(NULL,0,"PriceTrender",240,0,0,0,24,1,2);//trend before
double CLSellPT1_2 = iCustom(NULL,0,"PriceTrender",240,0,0,0,24,1,1);//trend now
double CLSellPT2_1 = iCustom(NULL,0,"PriceTrender",240,0,0,0,24,0,2);//price before
double CLSellPT2_2 = iCustom(NULL,0,"PriceTrender",240,0,0,0,24,0,1);//price now
//+------------------------------------------------------------------+
//| Variable End                                                     |
//+------------------------------------------------------------------+

//| Signal Begin(Exit buy & Exit sell)                                           |
if (CLBuyPT2_1 > CLBuyPT1_1 && CLBuyPT2_2 < CLBuyPT1_2) Close_All();
if (CLSellPT2_1 < CLSellPT1_1&&CLSellPT2_2 > CLSellPT1_2) Close_All();

//| Signal Begin(Entry long & Entry short)   

if (BuyPT2_1 < BuyPT1_1 && BuyPT2_2 > BuyPT1_1)  Order = SIGNAL_BUY;

if (SellPT2_1 > SellPT1_1 && SellPT2_2 < SellPT1_2) Order = SIGNAL_SELL;


//+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+

   //Buy
   
   double LOTS= NormalizeDouble(AccountFreeMargin()*Risk/100000,1);
   
   if ((Order == SIGNAL_BUY)&& (Bars != BarCount)) {
     
         //Check free margin
         if (AccountFreeMargin() < (1000 * LOTS)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

        
       Ticket = OrderSend(Symbol(), OP_BUY, LOTS, Ask, 0, 0, 0, "Buy(#" + MagicNumber + ")", MagicNumber, 0, DodgerBlue);
       OrderSelect(Ticket,SELECT_BY_TICKET);
       OrderModify(Ticket,OrderOpenPrice(),OrderOpenPrice()- SL*Point,OrderOpenPrice()+ TP*Point,0,Red);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("BUY order opened : ", OrderOpenPrice());
                
			} else {
				Print("Error opening BUY order : ", GetLastError());
			}
         }
         BarCount = Bars;
         return(0);
        
      
   }

   //Sell
   if ((Order == SIGNAL_SELL) && (Bars != BarCount)) {
     
         //Check free margin
         if (AccountFreeMargin() < (1000 * LOTS)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

        Ticket = OrderSend(Symbol(), OP_SELL, LOTS, Bid, 0, 0, 0, "Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
        OrderSelect(Ticket,SELECT_BY_TICKET);
        OrderModify(Ticket,OrderOpenPrice(),OrderOpenPrice() + SL*Point,OrderOpenPrice()-TP*Point,0,Red);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("SELL order opened : ", OrderOpenPrice());
                
			} else {
				Print("Error opening SELL order : ", GetLastError());
			
         }
         BarCount = Bars;
         return(0);
      }
   }

   BarCount = Bars;

   return(0);
}

///// function close orders

int Close_All()
{
bool   Result;
int    i,Pos,Error,Total;
//----
  
  Total=OrdersTotal();
  
     for(i=0; i<=Total; i++) 
     {
     RefreshRates();
        if(OrderSelect(i-1, SELECT_BY_POS, MODE_TRADES)==true) 
        {
           Pos=OrderType();
           if(Pos==OP_BUY || Pos==OP_SELL) 
           {
              if(Pos==OP_BUY) 
              Result=OrderClose(OrderTicket(),
                                OrderLots(),
                                Bid,
                                0,
                                CLR_NONE);
              else
              Result=OrderClose(OrderTicket(),
                                OrderLots(),
                                Ask,
                                0,
                                CLR_NONE);
              if(Result!=true) 
              { 
                 Error=GetLastError(); 
                 Print("LastError = ",Error); 
              }
              else Error=0;
           
        }
     }
  }
  BarCount = Bars;
  return(0);
}


//+------------------------------------------------------------------+